<?php

namespace Drupal\mason;

use Drupal\mason\Entity\Mason;
use Drupal\blazy\BlazyFormatter;

/**
 * Implements MasonFormatterInterface.
 */
class MasonFormatter extends BlazyFormatter implements MasonFormatterInterface {

  /**
   * {@inheritdoc}
   */
  public function buildSettings(array &$build, $items) {
    // Prepare integration with Blazy.
    $settings = &$build['settings'];
    $settings = array_merge($settings, MasonDefault::fixedSettings());

    // Pass basic info to parent::buildSettings().
    parent::buildSettings($build, $items);
  }

  /**
   * {@inheritdoc}
   */
  public function preBuildElements(array &$build, $items, array $entities = []) {
    parent::preBuildElements($build, $items, $entities);

    $settings = &$build['settings'];

    // Mason specific stuffs.
    $build['optionset'] = Mason::loadWithFallback($settings['optionset']);

    $this->getModuleHandler()->alter('mason_settings', $build, $items);
  }

}
